ServerEvents.recipes(event => {
    event.replaceInput(
        {type: 'ae2:inscriber'},
        'minecraft:gold_ingot',
        '#kubejs:grist/intelligent/basic'
    );
    event.replaceInput(
        {type: 'ae2:inscriber'},
        'minecraft:diamond',
        '#kubejs:grist/intelligent/basic'
    );

    event.recipes.ars_nouveau.imbuement(
        'ae2:charged_certus_quartz_crystal',
        'ae2:fluix_crystal',
        400,
        []
    );

    event.replaceInput(
        {type: 'ae2:item_transformation'},
        'minecraft:quartz',
        '#forge:dusts/quartz'
    );

    event.replaceInput(
        {mod: 'ae2'},
        'minecraft:quartz',
        '#forge:dusts/quartz'
    );
    
    event.shapeless('ae2:fluix_dust', ['ae2:fluix_crystal', '#alltheores:ore_hammers']);
    event.shapeless('ae2:sky_dust', ['ae2:sky_stone_block', '#alltheores:ore_hammers']);
    event.shapeless('ae2:certus_quartz_dust', ['#forge:gems/certus_quartz', '#alltheores:ore_hammers']);

    event.custom({
        type: "thermal:pulverizer",
        ingredients: [
            { tag: 'forge:gems/certus_quartz' }
        ],
        result: [
            { item: 'ae2:certus_quartz_dust' },
        ],
    });

    event.custom({
        type: "thermal:pulverizer",
        ingredients: [
            { item: 'ae2:fluix_crystal' }
        ],
        result: [
            { item: 'ae2:fluix_dust' },
        ],
    });
    event.custom({
        type: "thermal:pulverizer",
        ingredients: [
            { item: 'ae2:sky_stone_block' }
        ],
        result: [
            { item: 'ae2:sky_dust' },
        ],
    });

    event.custom({
        type: "thermal:press",
        ingredients: [
            { tag: 'kubejs:grist/intelligent/basic'},
            { item: "ae2:logic_processor_press" }
        ],
        result: [{item: 'ae2:printed_logic_processor'}]
    });
    event.custom({
        type: "thermal:press",
        ingredients: [
            { tag: 'kubejs:grist/intelligent/basic'},
            { item: "ae2:engineering_processor_press" }
        ],
        result: [{item: 'ae2:printed_engineering_processor'}]
    });
    event.custom({
        type: "thermal:press",
        ingredients: [
            { item: 'ae2:certus_quartz_crystal'},
            { item: "ae2:calculation_processor_press" }
        ],
        result: [{item: 'ae2:printed_calculation_processor'}]
    });

    event.custom({
        type: "thermal:press",
        ingredients: [
            { tag: 'forge:silicon'},
            { item: "ae2:silicon_press" }
        ],
        result: [{item: 'ae2:printed_silicon'}]
    });

    event.replaceInput(
        {id: 'ae2:network/parts/panels_semi_dark_monitor'},
        'minecraft:glowstone_dust',
        '#forge:dusts/copper'
    );
    
    event.replaceInput(
        {id: 'ae2:network/parts/panels_semi_dark_monitor'},
        'ae2:quartz_glass',
        '#forge:glass/colorless'
    );

    event.replaceInput(
        {id: 'ae2:tools/matter_cannon'},
        'minecraft:iron_ingot',
        '#kubejs:grist/build/improved'
    );
    event.recipes.thermal.smelter('4x ae2:quartz_glass', ["4x ae2:certus_quartz_dust", '4x #forge:glass', '#kubejs:grist/energetic/basic']);
    event.replaceInput(
        {id: 'ae2:misc/fluixpearl'},
        '#forge:ender_pearls',
        '#kubejs:grist/intelligent/improved'
    );

    event.replaceInput(
        {id: "ae2:network/crafting/cpu_crafting_unit"},
        "ae2:logic_processor",
        'kubejs:deep_intelligent_processor'
    );

    event.replaceInput(
        {id: "ae2:network/crafting/cpu_crafting_unit"},
        "ae2:calculation_processor",
        "kubejs:intelligent_processor"
    );

    event.replaceInput(
        {mod: 'ae2things'},
        'minecraft:netherite_ingot',
        '#kubejs:grist/intelligent/radiant'
    );
});